package com.muyu.system.service.impl;

import java.util.List;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.DateUtils;
import com.muyu.system.domain.resp.AsUserDeptNumResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.muyu.system.mapper.AsUserDeptMapper;
import com.muyu.system.domain.AsUserDept;
import com.muyu.system.service.IAsUserDeptService;
import org.springframework.transaction.annotation.Transactional;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author muyu
 * @date 2024-04-14
 */
@Service
public class AsUserDeptServiceImpl implements IAsUserDeptService
{
    @Autowired
    private AsUserDeptMapper asUserDeptMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public AsUserDept selectAsUserDeptById(Long id)
    {
        return asUserDeptMapper.selectAsUserDeptById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     *
     * @param asUserDept 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<AsUserDept> selectAsUserDeptList(AsUserDept asUserDept)
    {
        return asUserDeptMapper.selectAsUserDeptList(asUserDept);
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param asUserDept 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int insertAsUserDept(AsUserDept asUserDept)
    {
        asUserDept.setCreateTime(DateUtils.getNowDate());
        return asUserDeptMapper.insertAsUserDept(asUserDept);
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param asUserDept 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateAsUserDept(AsUserDept asUserDept)
    {
        asUserDept.setUpdateTime(DateUtils.getNowDate());
        return asUserDeptMapper.updateAsUserDept(asUserDept);
    }

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteAsUserDeptByIds(Long[] ids)
    {
        return asUserDeptMapper.deleteAsUserDeptByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteAsUserDeptById(Long id)
    {
        return asUserDeptMapper.deleteAsUserDeptById(id);
    }

    @Override
    @Transactional
    public Result updateAsUserDeptRead(Long id) {
        asUserDeptMapper.updateAsUserDeptRead(id);
        return Result.success();
    }

    @Override
    public Result<AsUserDeptNumResponse> getNum(Long noticeId) {
        Long num = asUserDeptMapper.selectAsUserDeptNum(noticeId);
        Long readNum = asUserDeptMapper.selectAsUserDeptReadNum(noticeId);
        long noReadNum = num-readNum;
        return Result.success(AsUserDeptNumResponse.builder()
                .num(num)
                .readNum(readNum)
                .noReadNum(noReadNum)
                .build());
    }
}
